#include "itext.h"
#include "xtext.h"
#include "xjp.h"
#include <ctype.h>


void SetOffset(char *flag,int x,int y)
{
        *flag = 0;

        if(x > 7) x = 7;
	if(x < -7) x = -7;
        if(y > 7) y = 7;
	if(y < -7) y = -7;

        if(x > 0){
                *flag = x;
        }else{
                *flag = x * -1; 
		OnFlag(*flag,4);
        }
        if(y > 0){
                *flag |= y * 16;
        }else{
                *flag |= y * 16 * -1; 
		OnFlag(*flag,8);
        }

	return;
}
void GetOffset(char flag,int *x,int *y)
{
        char i = 0;

	*x = 0; *y = 0;

        i = (flag & ~248);

        if(ChFlag(flag,4)){
                *x = i * -1;
	}else{
                *x = i;
	}

        if(ChFlag(flag,8)){
                OfFlag(flag,8); 

		i = (flag >> 4); 
		*y = i * -1;
        }else{
                i = (flag >> 4); 
		*y = i;
        }

	return;
}
void euc2utf8_c(iconv_t con,char *to,char *from,int from_len)
{
	size_t euc_len,utf8_len;

	char *utf8,*utf;
	char *euc;
	int len;

	if(from == NULL) return;

	euc_len = from_len;
	len = euc_len * 2;
	utf8_len = len;

	euc = from;
	if((utf8 = (char *)malloc(utf8_len)) == NULL) return;

	memset(utf8,0,utf8_len);

	utf = utf8;
	iconv(con,&euc,&euc_len,&utf8,&utf8_len);

	len -= utf8_len;
	memcpy(to,utf,len);
	*(to+len) = '\0';

	if(free != NULL) free(utf);
}
char * euc2utf8(iconv_t con,char *str,int len)
{
	size_t  euc_len,utf8_len,t_len;
	char *euc,*utf8,*utf;

	if(str == NULL) return NULL;

	euc_len = len;
	t_len = euc_len * 2;
	utf8_len = t_len;
	euc = str;

	if((utf8 = (char *)malloc(utf8_len)) == NULL) return NULL;
	memset(utf8,0,utf8_len);

	utf = utf8;
	iconv(con,&euc,&euc_len,&utf,&utf8_len);
	t_len -= utf8_len;
	*(utf8 + t_len) = '\0';

	return utf8;
}
static int  _16to10(unsigned char *p)
{
	char c;
	unsigned int f;

	if(*p >= '0' && *p <= '9'){
		f = *p - '0';

	}else if((*p >= 'a' && *p <= 'f') || (*p >= 'A' && *p <= 'F')){
		c = tolower(*p);
		f = c - 'a' + 10;
	}else{
		return -1;
	}

	return f;
}
unsigned int xstring2uint(char *str)
{
	unsigned char *p[2];
	unsigned int i,f,f0;

	if(!(*(str+0) == '0' && *(str+1) == 'x')) return -1;

	p[0] = (unsigned char *)str+2;
	p[1] = (unsigned char *)str+3;

	f = 0;
	for(i=0;i<2;i++){

		if((f0 = _16to10(p[i])) < 0) return -1;

		f = f * 16 + f0;
	}

	return f;
}
int checkStepNumber(char *str,char buf[],int step) 
{

	if(	strcmp(str,"0") == 0		||
		strcmp(str,"1") == 0		||
		strcmp(str,"2") == 0		||
		strcmp(str,"3") == 0		||
		strcmp(str,"4") == 0		||
		strcmp(str,"5") == 0		||
		strcmp(str,"6") == 0		||
		strcmp(str,"7") == 0		||
		strcmp(str,"8") == 0		||
		strcmp(str,"9") == 0		){

		if(step >= STEP_MAX - 1) 
			return step;

		buf[step++] = *str;
		buf[step] = '\0';

		return step;
	}else{
		buf[0] = '\0';
		return 0;
	}

	return -1;

}
int Double2Single(char *str0,char *str1,int len)
{
	int i,j;
        unsigned char *p,*p1;

        j = 0;
        for(i = 0; i < len; i++){
                p = (unsigned char *)str1 + i;
		if( *p == ' ' ) continue;

                if( *p == 0xa3 ){
                        p1 = p + 1;

                        if( (*p1 >= 0xb0 && *p1 < (0xb0+10))  ||

                            (*p1 >= 0xc1 && *p1 < (0xc1+26))  ||

                            (*p1 >= 0xe1 && *p1 < (0xe1+26))  ){

				*( str0 + j++ ) = *p1 - 128;
				i++;
			}

		}else if( *p == 0xa1 ){
                        p1 = p + 1;

                        if ( *p1 == 0xb2 ){ 
				*( str0 + j++ ) = *p1 - 83;
				i++;

                        }else if( *p1 == 0xa5 ){
                                *( str0 + j++ ) = *p1 - 119;
				i++;

                        }
                }else{
			*( str0 + j++ ) = *p;
		}

        }
        *( str0 + j ) = '\0';

        return 0;
}
